function upload(callbacks, options) {
    if (typeof callbacks !== 'function') {
        throw Error('请传入回调函数');
    }
    var _a = options || {}, type = _a.type, size = _a.size;
    var int = document.createElement('input');
    int.setAttribute('id', 'file_btn');
    int.setAttribute('type', 'file');
    int.style.display = 'none';
    document.body.appendChild(int);
    var input = document.getElementById('file_btn');
    input.click();
    input.addEventListener('change', function (e) {
        var files = e.target.files;
        if (!files)
            return;
        var fileExt = files[0].name.split('.').pop() || '';
        if (size && files[0].size >= size) {
            return callbacks(files, false, 'size');
        }
        if ((type === null || type === void 0 ? void 0 : type.length) && !type.includes(fileExt)) {
            return callbacks(files, false, 'type');
        }
        return callbacks(files);
    }, false);
    // if (!type && !size) {
    //     input.addEventListener('change', callbacks as EventListener, false)
    // } else {
    //     input.addEventListener(
    //         'change',
    //         function (e: Event) {
    //             const files = (e.target as HTMLInputElement).files
    //             if (!files) return
    //             const fileExt = files[0].name.split('.').pop() || ''
    //             if (size && files[0].size >= size) {
    //                 return callbacks(files, false, 'size')
    //             }
    //             if (type?.length && !type.includes(fileExt)) {
    //                 return callbacks(files, false, 'type')
    //             }
    //             return callbacks(files)
    //         },
    //         false
    //     )
    // }
    // 清理DOM
    setTimeout(function () {
        document.body.removeChild(input);
    }, 0);
}
function download(fileName, data) {
    var blob = new Blob([data], { type: 'application/octet-stream' });
    var href = window.URL.createObjectURL(blob);
    var link = document.createElement('a');
    link.style.display = 'none';
    link.href = href;
    link.download = decodeURIComponent(fileName);
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    window.URL.revokeObjectURL(href);
}
function uploadBase(file) {
    return new Promise(function (resolve) {
        var reader = new FileReader();
        reader.onload = function (e) {
            var _a;
            if ((_a = e.target) === null || _a === void 0 ? void 0 : _a.result) {
                resolve(e.target.result);
            }
        };
        reader.readAsDataURL(file);
    });
}

export { download, upload, uploadBase };
